package me.totalfreedom.totalfreedommod.command;

import me.totalfreedom.totalfreedommod.rank.GroupProvider;
import me.totalfreedom.totalfreedommod.rank.HierarchyProvider;
import me.totalfreedom.totalfreedommod.util.FLog;
import me.totalfreedom.totalfreedommod.util.FUtil;
import net.luckperms.api.model.user.User;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.concurrent.atomic.AtomicBoolean;

@CommandPermissions(permission = "op", source = SourceType.BOTH, cooldown = 5)
@CommandParameters(description = "OP a player", usage = "/<command> <partialname>")
public class Command_op extends FreedomCommand
{

    @Override
    public boolean run(CommandSender sender, Player playerSender, Command cmd, String commandLabel, String[] args, boolean senderIsConsole)
    {
        if (args.length < 1)
        {
            return false;
        }

        boolean silent = false;
        if (args.length == 2)
        {
            silent = args[1].equalsIgnoreCase("-s");
        }

        Player player = Bukkit.getServer().getPlayer(args[0]);

        if (player == null || plugin.al.isVanished(player.getUniqueId()))
        {
            msg(sender, PLAYER_NOT_FOUND);
            return true;
        }

        AtomicBoolean atomicBoolean = new AtomicBoolean(silent);
        User user = GroupProvider.getUser(player);
        HierarchyProvider.OP.getHierarchy().promoteUser(user).whenComplete((ignored, throwable) ->
        {
            if (throwable != null)
            {
                FLog.severe("Failed to promote user " + player.getName());
                return;
            }

            msg(player, YOU_ARE_OP);
            plugin.rm.updateDisplay(player);
            if (!atomicBoolean.get())
            {
                FUtil.adminAction(sender.getName(), "Opping " + player.getName(), false);
            }
        });


        return true;
    }
}